#
# filter the rman generated HTML file to include our own header stuff
# into the generated HTML
#

BEGIN	{
	body = 0;
	debug = 0;

	printf("\n"	\
	       "<!-- manual page source format generated by PolyglotMan v3.2, -->\n"	\
	       "<!-- available at http://polyglotman.sourceforge.net/ -->\n"	\
	       "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n"	\
	       "<head>\n"	\
	       "<link rel=\"stylesheet\" href=\"chunky.css\" type=\"text/css\" />\n"	\
	       "\n"	\
	       );
}



/<title>/	{
	line = $0;

	sub(/"pavuk\("\)/, "pavuk", line);

	printf("%s\n", line);
}


				{
	if (body)
	{
		line = $0;

		# 
		# repair rman output bugs. Don't care too much about dangling </a> tags and all as
                # htmltidy will fix that for us :-)
                #
		
		# 
                # case 1:  
                #   
                #      <a href='http_proxy'>http_proxy 
                #
                # and comparable items should NOT get a href: rman triggers on 'http' without the mandatory ':'.
                #
		if (0)
			gsub(/<a href='http[^s:][^>]+>/, " XXXHREFXXX ", line);
		else
			gsub(/<a href='http[^s:][^>]+>/, "", line);

		# 
                # case 2:  
                #   
                #      <a href='https://[[user][:password] ...
                #
                # and comparable items in the example sections of the man page
                #
		if (0)
			gsub(/<a href='http[s]?:\/\/[^a-zA-Z][^>]+>/, " XXXEXAMPLEXXXHREFXXX ", line);
		else
			gsub(/<a href='http[s]?:\/\/[^a-zA-Z][^>]+>/, "", line);
	



		gsub("T&lt;", " ", line);
		gsub("T&gt;", " ", line);

		# dirty rotten hack meant to fix some serious screwups at the start of the document:
		gsub(/<\/pre> <b>pavuk<\/b> kx/, "<p><b>pavuk</b> ", line);	



		if (match(line, /<blockquote><\/li><li>Report every run/))
		{
			Astate = 1;
			gsub(/<blockquote><\/li><li>Report every run/, "<blockquote><dl><dt>0</dt><dd><p>Report every run", line);
if (debug) line = line  " Astate=" Astate " ";
		}
		if (Astate == 1 && match(line, /<\/pre><\/li><li>/))
		{
			Astate++;
			gsub(/<\/pre><\/li><li>/, "</pre></dd><dt>1</dt><dd><p>", line);
if (debug) line = line  " Astate=" Astate " ";
		}
		if (Astate == 2 && match(line, /<\/blockquote>/))
		{
			Astate++;
			gsub(/<\/blockquote>/, "</blockquote></dd></dl>", line);
if (debug) line = line  " Astate=" Astate " ";
		}


		if (match(line, /Supported macros are: <blockquote><\/dd>/))
		{
			Bstate = 1;
			gsub(/Supported macros are: <blockquote><\/dd>/, "Supported macros are: <blockquote><dl>", line);
if (debug) line = line  " Bstate=" Bstate " ";
		}
		if (Bstate == 1 && match(line, /<\/li>...<li>/))
		{
			Bstate++;
			gsub(/<\/li>...<li>/, "</dd><dt>...</dt><dd>", line);
if (debug) line = line  " Bstate=" Bstate " ";
		}
		if (Bstate == 2 && match(line, /<\/b> +<\/li>/))
		{
			Bstate++;
			gsub(/<\/b> +<\/li>/, "</b> ", line);
if (debug) line = line  " Bstate=" Bstate " ";
		}
		if (Bstate == 3 && match(line, /<\/ul>/))
		{
			Bstate++;
			gsub(/<\/ul>/, "", line);
if (debug) line = line  " Bstate=" Bstate " ";
		}
		if (Bstate == 4 && match(line, /function <\/blockquote>/))
		{
			Bstate++;
			gsub(/function <\/blockquote>/, "function </dd></dl></blockquote>  </dd>", line);
if (debug) line = line  " Bstate=" Bstate " ";
		}
		if (Bstate == 5 && match(line, /<dl>/))
		{
			Bstate++;
			gsub(/<dl>/, "", line);
if (debug) line = line  " Bstate=" Bstate " ";
		}


		gsub(/<blockquote><\/dd>/, "<blockquote><dl>", line);
		gsub(/<blockquote><\/li><li>/, "<blockquote><ul><li>", line);


		if (match(line, /<dd><\/dd>/))
		{
			Cstate = 1;
			gsub(/<dd><\/dd>/, "<dd>", line);
if (debug) line = line  " Cstate=" Cstate " ";
		}
		if (Cstate == 1 && match(line, /<\/dl>/))
		{
			Cstate++;
			gsub(/<\/dl>/, " ", line);
if (debug) line = line  " Cstate=" Cstate " ";
		}
		if (Cstate == 2 && match(line, /<\/blockquote>/))
		{
			Cstate++;
			gsub(/<\/blockquote>/, "</dd></dl></blockquote> </dd></dl>", line);
if (debug) line = line  " Cstate=" Cstate " ";
		}
		


		if (match(line, /<\/li><li><\/li>/))
		{
			Dstate = 1;
			gsub(/<li><\/li>/, "<li>", line);
if (debug) line = line  " Dstate=" Dstate " ";
		}
		if (Dstate == 1 && match(line, /<\/ul>/))
		{
			Dstate++;
			gsub(/<\/ul>/, " ", line);
if (debug) line = line  " Dstate=" Dstate " ";
		}
		if (Dstate == 2 && match(line, /<\/blockquote>/))
		{
			Dstate++;
			gsub(/<\/blockquote>/, "</li></ul></blockquote> ", line);
if (debug) line = line  " Dstate=" Dstate " ";
		}


		if (match(line, /<dd>as previous, <\/dd>/))
		{
			Estate = 1;
			gsub(/<\/dd>/, " ", line);
if (debug) line = line  " Estate=" Estate " ";
		}
		if (Estate == 1 && match(line, /<\/dl>/))
		{
			Estate++;
			gsub(/<\/dl>/, " ", line);
if (debug) line = line  " Estate=" Estate " ";
		}
		if (Estate == 2 && match(line, /<\/blockquote>/))
		{
			Estate++;
			gsub(/<\/blockquote>/, "</dd></dl></blockquote>    </dd></dl> ", line);
if (debug) line = line  " Estate=" Estate " ";
		}


		if (match(line, /tls1 <\/li><\/ul><\/blockquote>/))
		{
			Fstate = 1;
if (debug) line = line  " Fstate=" Fstate " ";
		}
		if (Fstate == 1 && match(line, /<dl>/))
		{
			Fstate++;
			gsub(/<dl>/, "  </dd></dl>           <dl>", line);
if (debug) line = line  " Fstate=" Fstate " ";
		}


		if (match(line, /<\/li><li>returns numeric/))
		{
			Gstate = 1;
if (debug) line = line  " Gstate=" Gstate " ";
		}
		if (Gstate == 1 && match(line, /<\/li> *$/))
		{
			Gstate++;
			gsub(/<\/li> *$/, " ", line);
if (debug) line = line  " Gstate=" Gstate " ";
		}
		if (Gstate == 2 && match(line, /<\/ul> *$/))
		{
			Gstate++;
			gsub(/<\/ul> *$/, " ", line);
if (debug) line = line  " Gstate=" Gstate " ";
		}
		if (Gstate == 3 && match(line, /<\/blockquote>/))
		{
			Gstate++;
			gsub(/<\/blockquote>/, "</li></ul></blockquote>", line);
if (debug) line = line  " Gstate=" Gstate " ";
		}


		if (match(line, /<dd><blockquote><ul><li>/))
		{
			Hstate = 1;
if (debug) line = line  " Hstate=" Hstate " ";
		}
		if (Hstate == 1 && match(line, /<\/li><\/ul><\/blockquote>/))
		{
			Hstate++;
			gsub(/<\/li><\/ul><\/blockquote>/, "</li></ul></blockquote>     </dd></dl>", line);
if (debug) line = line  " Hstate=" Hstate " ";
		}


		if (match(line, /or libdes libraries. <\/dd>/))
		{
			Istate = 1;
if (debug) line = line  " Istate=" Istate " ";
		}
		if (Istate == 1 && match(line, /<\/blockquote>/))
		{
			Istate++;
			gsub(/<\/blockquote>/, "</blockquote>     </dd></dl>", line);
if (debug) line = line  " Istate=" Istate " ";
		}


		if (match(line, /including sub-expressions.+<\/li>/))
		{
			Jstate = 1;
if (debug) line = line  " Jstate=" Jstate " ";
		}
		if (Jstate == 1 && match(line, /<\/blockquote>/))
		{
			Jstate++;
			gsub(/<\/blockquote>/, "</blockquote>     </dd></dl>", line);
if (debug) line = line  " Jstate=" Jstate " ";
		}


		if (match(line, /\(sc \(ss \(md5 %h\) 0 2\)/))
		{
			Kstate = 1;
if (debug) line = line  " Kstate=" Kstate " ";
		}
		if (Kstate == 1 && match(line, /<dl>/))
		{
			Kstate++;
			gsub(/<dl>/, "</dd></dl>            ", line);
if (debug) line = line  " Kstate=" Kstate " ";
		}


		if (match(line, /<b>js<\/b>/))
		{
			Lstate = 1;
if (debug) line = line  " Lstate=" Lstate " ";
		}
		if (Lstate == 1 && match(line, /<\/blockquote>/))
		{
			Lstate++;
			gsub(/<\/blockquote>/, "</blockquote>     </dd></dl>", line);
if (debug) line = line  " Lstate=" Lstate " ";
		}


		if (match(line, /int32, defined always/))
		{
			Mstate = 1;
if (debug) line = line  " Mstate=" Mstate " ";
		}
		if (Mstate == 1 && match(line, /<\/blockquote>/))
		{
			Mstate++;
			gsub(/<\/blockquote>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 2 && match(line, /<\/blockquote> +<\/dd><\/dl>/))
		{
			Mstate++;
			gsub(/<\/blockquote> +<\/dd><\/dl>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 3 && match(line, /<\/blockquote> +<\/dd><\/dl>/))
		{
			Mstate++;
			gsub(/<\/blockquote> +<\/dd><\/dl>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 4 && match(line, /<\/blockquote> +<\/dd><\/dl>/))
		{
			Mstate++;
			gsub(/<\/blockquote> +<\/dd><\/dl>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 5 && match(line, /<\/blockquote>/))
		{
			Mstate++;
			gsub(/<\/blockquote>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 6 && match(line, /<\/blockquote> +<\/dd><\/dl>/))
		{
			Mstate++;
			gsub(/<\/blockquote> +<\/dd><\/dl>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 7 && match(line, /<\/blockquote> +<\/dd><\/dl>/))
		{
			Mstate++;
			gsub(/<\/blockquote> +<\/dd><\/dl>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 8 && match(line, /<ul>/))
		{
			Mstate++;
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 9 && match(line, /<\/blockquote>/))
		{
			Mstate++;
			gsub(/<\/blockquote>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 10 && match(line, /<ul>/))
		{
			Mstate++;
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 11 && match(line, /<\/blockquote>/))
		{
			Mstate++;
			gsub(/<\/blockquote>/, "</blockquote>     </li></ul>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}
		else if (Mstate == 12 && match(line, /<\/blockquote>/))
		{
			Mstate++;
			gsub(/<\/blockquote>/, "</blockquote>    </dd></dl>", line);
if (debug) line = line  " Mstate=" Mstate " ";
		}


		if (match(line, /level == 3/))
		{
			Nstate = 1;
if (debug) line = line  " Nstate=" Nstate " ";
		}
		if (Nstate == 1 && match(line, /<\/blockquote>/))
		{
			Nstate++;
			gsub(/<\/blockquote>/, "</blockquote>     </dd></dl>", line);
if (debug) line = line  " Nstate=" Nstate " ";
		}



		if (match(line, /all supported functions\/operators:/))
		{
			Ostate = 1;
if (debug) line = line  " Ostate=" Ostate " ";
		}
		if (Ostate == 1 && match(line, /<blockquote>/))
		{
			Ostate++;
			gsub(/<blockquote>/, " ", line);
if (debug) line = line  " Ostate=" Ostate " ";
		}



		if (match(line, /if equal <\/dd><\/dl>/))
		{
			Pstate = 1;
if (debug) line = line  " Pstate=" Pstate " ";
		}
		if (Pstate == 1 && match(line, /^<\/blockquote>/))
		{
			Pstate++;
			gsub(/<\/blockquote>/, " ", line);
if (debug) line = line  " Pstate=" Pstate " ";
		}



		if (match(line, /<b>sp<\/b>/))
		{
			Qstate = 1;
if (debug) line = line  " Qstate=" Qstate " ";
		}
		if (Qstate == 1 && match(line, /<\/blockquote>/))
		{
			Qstate++;
			gsub(/<\/blockquote>/, " ", line);
if (debug) line = line  " Qstate=" Qstate " ";
		}



		if (match(line, /1 -- if document/))
		{
			Rstate = 1;
if (debug) line = line  " Rstate=" Rstate " ";
		}
		if (Rstate == 1 && match(line, /0 -- <\/li>/))
		{
			Rstate++;
			gsub(/0 -- <\/li>/, "0 --  ", line);
if (debug) line = line  " Rstate=" Rstate " ";
		}
		if (Rstate == 2 && match(line, /<\/ul>/))
		{
			Rstate++;
			gsub(/<\/ul>/, " ", line);
if (debug) line = line  " Rstate=" Rstate " ";
		}
		if (Rstate == 3 && match(line, /<\/blockquote>/))
		{
			Rstate++;
			gsub(/<\/blockquote>/, " ", line);
if (debug) line = line  " Rstate=" Rstate " ";
		}
		if (Rstate == 4 && match(line, /<dl>/))
		{
			Rstate++;
			gsub(/<dl>/, "</li></ul></dd> ", line);
if (debug) line = line  " Rstate=" Rstate " ";
		}

		if (match(line, /strftime\.3/))
		{
			Sstate = 1;
if (debug) line = line  " Sstate=" Sstate " ";
		}
		if (Sstate == 1 && match(line, /<\/li>/))
		{
			gsub(/<\/li>/, "", line);
if (debug) line = line  " Sstate=" Sstate " ";
		}
		if (Sstate == 1 && match(line, /<\/ul>/))
		{
			gsub(/<\/ul>/, "", line);
if (debug) line = line  " Sstate=" Sstate " ";
		}
		if (Sstate == 1 && match(line, /<\/blockquote>/))
		{
			gsub(/<\/blockquote>/, "", line);
if (debug) line = line  " Sstate=" Sstate " ";
		}
		if (Sstate == 1 && match(line, /<dl>/))
		{
			Sstate++;
			gsub(/<dl>/, "</dd></dl>", line);
if (debug) line = line  " Sstate=" Sstate " ";
		}


		if (match(line, /<dt>R *<\/dt>/))
		{
			Tstate = 1;
if (debug) line = line  " Tstate=" Tstate " ";
		}
		else if (Tstate == 1 && match(line, /<ul>/))
		{
			Tstate++;
			gsub(/<ul>/, "", line);
if (debug) line = line  " Tstate=" Tstate " ";
		}
	


		# -fnrules fixes
		gsub(/filename for URL <\/dd><\/dl><\/blockquote> +<\/dd><\/dl>/, "filename for URL </dd></dl></blockquote> ", line);
		gsub(/URL string <\/dd><\/dl><\/blockquote> +<\/dd><\/dl>/, "URL string </dd></dl></blockquote> ", line);
		gsub(/macro: <blockquote>/, "macro: ", line);
		gsub(/recognized macros: <blockquote>/, "recognized macros: ", line);
		gsub(/URL string <\/dd><\/dl><\/blockquote> +<\/dd><\/dl>/, "URL string </dd></dl></blockquote> ", line);
		gsub(/URL string <\/dd><\/dl><\/blockquote> +<\/dd><\/dl>/, "URL string </dd></dl></blockquote> ", line);
		gsub(/URL string <\/dd><\/dl><\/blockquote> +<\/dd><\/dl>/, "URL string </dd></dl></blockquote> ", line);
		gsub(/URL string <\/dd><\/dl><\/blockquote> +<\/dd><\/dl>/, "URL string </dd></dl></blockquote> ", line);

		gsub(/XXXfiles/, "XXX files", line);

		gsub(/<dt>%o <\/dt>/, "<dt><b>%o</b> </dt>", line);
		gsub(/<dt>%U <\/dt>/, "<dt><b>%U</b> </dt>", line);
		gsub(/<dt>sc <\/dt>/, "<dt><b>sc</b> </dt>", line);


		gsub(/<a href='https\/host_port\/\[document\]\[\?query\]'>/, "", line);
		gsub(/<a href='mime\.types\.5'>/, "", line);
		gsub(/<a href='http'>/, "", line);
		gsub(/<a href='https'>/, "", line);
		gsub(/<a href='get_parent\.n'>/, "", line);
		gsub(/la<a href='http:\/\/pavuk\.sourceforge\.net\/ra'>http:\/\/pavuk\.sourceforge\.net\/ra<\/a>/, "<a href='http://pavuk.sourceforge.net/'>http://pavuk.sourceforge.net/</a>", line);

		gsub(/<\/h3>/, "</h3><p>", line);
		gsub(/<\/h2>/, "</h2><p>", line);

		####################################################
		#
		# htmltidy preparations: add paragraph markers where we wish to have 'em:
		#
		gsub(/<dd>/, "<dd><p>", line);
		# gsub(/<dt>/, "<dt><p>", line);
		

		# ditch most of the <blockquote> fluff:
		gsub(/<blockquote><br>/, "<blockquote>", line);
		gsub(/<blockquote><b>/, "<blockquote><p><b>", line);
		gsub(/<blockquote><dl>/, "<dl>", line);
		gsub(/<blockquote><ul>/, "<ul>", line);
		gsub(/<\/dl><\/blockquote>/, "</dl>", line);
		gsub(/<\/ul><\/blockquote>/, "</ul>", line);
		
		gsub(/<p> +<br>/, "<p>", line);

		gsub(/<tr><td align='left'>l l\.<\/td><\/tr>/, "<tr><td colspan='2'><hr></td></tr> ", line);

		# last: fix the first header to be a <h1> as it should:
		if (match(line, /<h2><a name='sect0'/))
		{
			sub(/<h2/, "<h1", line);
			sub(/<\/h2/, "</h1", line);
		}

		# make sure constructs such as "<b>$p </b>is" become "<b>$p</b> is":
		gsub(/<\/i>/, "</i> ", line);
		gsub(/<\/b>/, "</b> ", line);
		gsub(/ <\//, "</", line);



		# additional <quote> postprocessing:
		if (!match(line, /-tr_str_str/))
		{
			gsub(/&lsquo;&lsquo;/, "\\&ldquo;", line);
			gsub(/&rsquo;&rsquo;/, "\\&rdquo;", line);
		}

		printf("%s\n", line);
	}
}



# WARNING: the 'body' rule must be the last one in this script!

/<body/				{
	body = 1;
	printf("</head>\n<body>\n", $0);
}



