/***************************************************************************/
/*    This code is part of WWW grabber called pavuk                        */
/*    Copyright (c) 1997 - 2001 Stefan Ondrejicka                          */
/*    Distributed under GPL 2 or later                                     */
/***************************************************************************/

#ifndef _absio_h_
#define _absio_h_

#ifdef __QNX__
#define tl_sock_read(fd, buf, size, ssld) tl_unix_read(fd, buf, size, ssld)
#define tl_sock_nbread(fd, buf, size, ssld) tl_unix_nbread(fd, buf, size, ssld)
#define tl_sock_write(fd, buf, size, ssld) tl_unix_write(fd, buf, size, ssld)
#define tl_file_read(fd, buf, size) read(fd, buf, size)
#define tl_file_write(fd, buf, size) write(fd, buf, size)
#elif defined __BEOS__
/* [i_a] BeOS patch changed; VERY similar to Win32 needs BTW */
#define tl_sock_read(fd, buf, size, ssld) tl_unix_recv(fd, buf, size, ssld)
#define tl_sock_nbread(fd, buf, size, ssld) tl_unix_nbrecv(fd, buf, size, ssld)
#define tl_sock_write(fd, buf, size, ssld) tl_unix_send(fd, buf, size, ssld)
#define tl_file_read(fd, buf, size) read(fd, buf, size)
#define tl_file_write(fd, buf, size) write(fd, buf, size)
#elif defined(WIN32) || defined(__WIN32)
#define tl_sock_read(fd, buf, size, ssld) tl_unix_read(fd, buf, size, ssld)
#define tl_sock_nbread(fd, buf, size, ssld) tl_unix_nbread(fd, buf, size, ssld)
#define tl_sock_write(fd, buf, size, ssld) tl_unix_write(fd, buf, size, ssld)
#define tl_file_read(fd, buf, size) read(fd, buf, size)
#define tl_file_write(fd, buf, size) write(fd, buf, size)
#else
#define tl_sock_read(fd, buf, size, ssld) tl_unix_read(fd, buf, size, ssld)
#define tl_sock_nbread(fd, buf, size, ssld) tl_unix_nbread(fd, buf, size, ssld)
#define tl_sock_write(fd, buf, size, ssld) tl_unix_write(fd, buf, size, ssld)
/*
 * [i_a] It's nice that UNIX handles file I/O and network I/O the same when we consider
 * the read() and write() functions and the handles, but for our debug/trace functionality
 * benefit it's rather oportune to separate these: we're NOT interested in logging all
 * file I/O where '-debug net' is specified on the commandline.
 */
#define tl_file_read(fd, buf, size) read(fd, buf, size)
#define tl_file_write(fd, buf, size) write(fd, buf, size)
#endif

/* [i_a] BeOS patch changed; VERY similar to Win32 needs BTW */
extern ssize_t tl_unix_read(int sock, char *buf, size_t len, void *ssl_con);
extern ssize_t tl_unix_nbread(int sock, char *buf, size_t len, void *ssl_con);
extern ssize_t tl_unix_write(int sock, const char *buf, size_t len, void *ssl_con);
extern int tl_selectr(int sock, long int timeout);
extern int tl_selectw(int sock, long int timeout);

#endif

