/***************************************************************************/
/*    This code is part of WWW grabber called pavuk                        */
/*    Copyright (c) 1997 - 2001 Stefan Ondrejicka                          */
/*    Distributed under GPL 2 or later                                     */
/***************************************************************************/

#ifndef _authinfo_h_
#define _authinfo_h_

#include "dllist.h"
#include "url.h"
#include "http.h"

typedef struct
{
    protocol prot;
    char *host;
    int port;
    char *user;
    char *pass;
    char *base;
    char *realm;
    char *ntlm_domain;
    http_auth_type_t type;
} authinfo;

extern dllist *authdata;

extern http_auth_type_t authinfo_get_type(const char *str);

extern authinfo *authinfo_match_entry(protocol prot, const char *host, int port, const char *path, const char *realm);

extern int authinfo_load(const char *fn);
extern int authinfo_save(const char *fn);

#define free_deep_authinfo(entry) \
    _free((entry)->pass); \
    _free((entry)->user); \
    _free((entry)->host); \
    _free((entry)->base); \
    _free((entry)->ntlm_domain); \
    _free(entry);


#endif

