/***************************************************************************/
/*    This code is part of WWW grabber called pavuk                        */
/*    Copyright (c) 1997 - 2001 Stefan Ondrejicka                          */
/*    Distributed under GPL 2 or later                                     */
/***************************************************************************/

#ifndef _gprop_h_
#define _gprop_h_

typedef struct
{
    enum
    {
        GPROP_STR,
        GPROP_INT,
        GPROP_BOOL
    } type;
    char *name;
    void *value;
} gprop;

extern gprop *gprop_parse(char *);
extern char *gprop_dump(gprop *);
extern void gprop_add(gprop *);
extern void gprop_set_str(const char *name, const char *value);
extern void gprop_set_int(const char *name, int value);
extern void gprop_set_bool_t(const char *name, int value);
extern int gprop_get_str(char *name, char **valp);
extern int gprop_get_int(char *name, int *valp);
extern int gprop_get_bool_t(char *name, int *valp);
extern void gprop_save(FILE *);

#endif

