/***************************************************************************/
/*    This code is part of WWW grabber called pavuk                        */
/*    Copyright (c) 1997 - 2001 Stefan Ondrejicka                          */
/*    Distributed under GPL 2 or later                                     */
/***************************************************************************/

#ifndef _pavuk_gui_api_h_
#define _pavuk_gui_api_h_

#include "bufio.h"
#include "url.h"
#include "doc.h"


#if defined(I_FACE)

extern void gui_beep(void);

extern void gui_loop_serve(DBGdeclvoid(void));
#define gui_loop_serve()    gui_loop_serve(DBGvoid())

#if !defined(HAVE_MT)
extern void gui_loop_escape(void);
extern void gui_loop_do(void);
#else
#define gui_loop_escape()
#define gui_loop_do()
#endif

extern void gui_start(int *, char **);
extern void gui_main(void);

extern void gui_create_tree_root_node(void);
extern void gui_clear_tree(void);
extern void *gui_tree_make_entry(url *);
extern void gui_tree_set_icon(url *);
extern void gui_tree_add_start(void);
extern void gui_tree_add_end(void);
extern void gui_tree_set_icon_for_doc(doc *);

extern void gui_start_download(void);
extern void gui_finish_download(void);
extern void gui_finish_document(doc *);

extern void gui_mt_thread_start(int);
extern void gui_mt_thread_end(int);

extern void gui_set_doccounter(void);
extern void gui_set_progress(char *sz, char *rate, char *etime, char *rtime);
extern void gui_set_msg(char *text, int tout);
extern void gui_set_status(char *);
extern void gui_set_url(char *);
extern void gui_clear_status(void);

#if !defined(HAVE_MT)
extern void gui_msleep(long msec);
extern int gui_wait_io(int sock, int for_read, long timeout);
#endif

extern void gui_xprint(char *str);

extern void gui_do_ui_cleanup(void);

#else

#define gui_loop_serve()
#define gui_loop_escape()
#define gui_loop_do()

#define gui_set_msg(t, n) DEBUG_USER(" - %s\n", t)
#define gui_set_status(t) DEBUG_USER(" - %s\n", t)
#define gui_clear_status()

#endif

#endif /* _pavuk_gui_api_h_ */

