/***************************************************************************/
/*    This code is part of WWW grabber called pavuk                        */
/*    Copyright (c) 1997 - 2001 Stefan Ondrejicka                          */
/*    Distributed under GPL 2 or later                                     */
/***************************************************************************/

#ifndef _jsbind_h_
#define _jsbind_h_

#include "config.h"

#if defined(HAVE_MOZJS)

#include "condition.h"
#include "lfname.h"
#include "htmlparser.h"

typedef enum
{
    PJS_DPH_STORE,
} pjs_phase_t;

extern int pjs_destroy(void);
extern int pjs_init(void);
extern int pjs_load_script(const char *name);
extern int pjs_load_script_string(const char *str);
extern int pjs_execute(const char *);

extern int pjs_run_cond_check_func(url *urlp, cond_info_t *condp);
extern char *pjs_run_fnrules_func(char *, struct lfname_lsp_interp *);

extern int pjs_run_parse_content_func(char *content, size_t content_length, char *type_id, char *mime_type, url *urlp, int level);

extern int pjs_run_parse_css_content_func(html_parser_t *hpinfo, html_extract_info_t *einfo);
extern int pjs_run_parse_raw_html_content_func(html_parser_t *hpinfo, html_extract_info_t *einfo);
extern int pjs_run_parse_js_content_func(html_parser_t *hpinfo, html_extract_info_t *einfo);
extern int pjs_run_doc_process_func(doc *docp, pjs_phase_t phase);

extern const char *pjs_GetJaveScriptLibraryVersion(void);

#else

#define pjs_run_doc_process_func(func, mode) /**/

#endif /* HAVE_MOZJS */

#endif

