/***************************************************************************/
/*    This code is part of WWW grabber called pavuk                        */
/*    Copyright (c) 1997 - 2001 Stefan Ondrejicka                          */
/*    Distributed under GPL 2 or later                                     */
/***************************************************************************/

#ifndef _pavuk_re_h_
#define _pavuk_re_h_

#if defined(HAVE_REGEX)

#if defined(HAVE_POSIX_REGEX)

#if defined(HAVE_REGEX_H)
#include <regex.h>
#endif

typedef struct
{
    regex_t preg;
    char *pattern;
} re_entry;

#elif defined(HAVE_V8_REGEX)

#if defined(HAVE_REGEXP_H)
#include <regexp.h>
#elif defined(HAVE_REGEX_H)
#include <regex.h>
#endif

typedef struct
{
    regexp *preg;
    char *pattern;
} re_entry;

#elif defined(HAVE_BSD_REGEX)

#if defined(HAVE_REGEX_H)
#include <regex.h>
#endif

typedef struct
{
    char *pattern;
} re_entry;

#elif defined(HAVE_GNU_REGEX)

#if defined(HAVE_REGEX_H)
#include <regex.h>
#endif

typedef struct
{
    struct re_pattern_buffer preg;
    char *pattern;
} re_entry;

#elif defined(HAVE_PCRE_REGEX)

#if defined(HAVE_PCRE_H)
#include <pcre.h>
#elif defined(HAVE_REGEX_H)
#include <regex.h>
#endif

typedef struct
{
    pcre *preg;
    pcre_extra *preg_extra;
    char *pattern;
} re_entry;

#elif defined(HAVE_TRE_REGEX)

#if defined(HAVE_TRE_REGEX_H)
#include <tre/regex.h>
#elif defined(HAVE_REGEX_H)
#include <regex.h>
#endif

typedef struct
{
    regex_t preg;
    char *pattern;
} re_entry;

#else

#error "REGEX support turned on but no suitable REGEX library has been configured!"

#endif

extern int re_subexpr_info(re_entry *ree, int *nr);
extern re_entry *re_make(const char *);
extern void re_free(re_entry *);
extern int re_pmatch(re_entry *, const char *);
extern int re_pmatch_subs(re_entry *, const char *, int *, int **);

#endif /* HAVE_REGEX */
#endif

