#! /bin/sh

# 0.9.36 FTP error flow / report test

#
# Test pavuk [error] flow in case DNS doesn't resolve for FTP site
#
# Originally, tl_select() would barf with an error on a sock = -1, which
# is 'good' (if reports an error), but the code flow is questionable as the
# DNS resolve should already have caused an activity abort anyway.
#

../src/pavuk ftp://ftp.cs.titech.ac.jp
#      -debug -verbose -debug_level all,!mtlock,!locks,!dev,!trace



#
# another error test case for the DNS
#

../src/pavuk ftp://utsun.s.u-tokyo.ac.jp/ftpsync/prep -ftp_passive



#
# an ACTIVE FTP test
#

../src/pavuk ftp://ftp.informatik.rwth-aachen.de/pub/gnu/ -singlepage



#
# multiple sites; first does not connect (no DNS error, the FTP server
# apparently has been moved), the second has some issues with 
# LIST vs. NLST support for directory listings.
#
# NOTE: the second site is a bit 'funny' in that *some* directories
#       seem to react well to the NLST (ls) command, while others
#       report emptiness unless you LIST (dir).
#

../src/pavuk ftp://viz.tamu.edu ftp://svr-ftp.eng.cam.ac.uk -FTPdir -ftp_passive
#       -debug -verbose -debug_level all,!mtlock,!locks,!dev,!trace


